Imports System.io
Imports System.Math

Module MpPI
    Sub Main()
        Console.WriteLine("------- Pi Calculation (Gauss-Legendre) -------")

        Console.Write("How many digits do you want? > ")
        Dim dc As Integer = Integer.Parse(Console.ReadLine())

        Console.WriteLine("Output file name? (If no input, the result will be displayed in this screen.)")
        Console.Write("> ")
        Dim filename As String = Console.ReadLine()

        Dim pi() As Byte

        Dim StartTime As Date = Date.Now
        Console.Write(" --- Calculation Started at ")
        Console.WriteLine(StartTime)

        MpPIGL(CInt(dc / 2.408) + 10, pi)

        Dim EndTime As Date = Date.Now
        Console.Write(" --- Completed at ")
        Console.WriteLine(EndTime)
        Console.Write("Elapsed time : ")
        Console.Write(CInt(Date.Now.Subtract(StartTime).TotalMilliseconds))
        Console.WriteLine("ms")

        Console.WriteLine("Converting to Decimal String")
        Dim s As String = pi(0).ToString & "." & RadixToDecFrac(pi, 1, dc)

        If filename.Length = 0 Then
            Console.WriteLine("No file name has been specified.")
            Console.WriteLine("The result will be displayed below. OK? (Hit Enter key.)")
            Console.ReadLine()

            Console.WriteLine(s)
        Else
            Dim sw As New StreamWriter(New FileStream(filename, FileMode.Create))
            sw.Write(s)
            sw.Close()

            Console.Write("The results has been stored in the file : ")
            Console.WriteLine(filename)
        End If

        Console.WriteLine("------- Hit Enter key to quit. -------")
        Console.ReadLine()
    End Sub

    Public Sub MpPIGL(ByVal np As Integer, ByRef pi() As Byte)
        Const MACC As Integer = 5
        Dim n As Integer = np + MACC

        'a = 1
        Dim a(n) As Byte
        a(0) = 1

        'b = 1/SQRT(2)
        Dim two() As Byte = {2}
        Dim b(n) As Byte
        Dim dum(n) As Byte
        MpSQRT(two, 0, 1, dum, b)
        Erase dum

        't = 1/4
        Dim t(n) As Byte
        t(1) = 64

        'p = 1
        Dim p(n) As Byte
        p(n - 1) = 1
        Dim rpp As Integer = 0

        Dim x(n) As Byte
        Dim s(2 * n - 1) As Byte
        Dim binv() As Byte

        Dim ir As Integer
        Do
            'x = (a + b) / 2
            MpADD(a, 0, b, 0, n, x)
            MpSDV(x, 1, n, 2, x, ir)

            'y = SQRT(a * b)
            MpMUL(a, 0, n, b, 0, n, s)
            If binv Is Nothing Then
                ReDim binv(n)
                MpSQRT(s, 1, n, b, binv)
            Else
                MpSQRT(s, 1, n, b, binv, binv)
            End If

            't = t - p * (a - x) * (a - x)
            Dim isign As Integer
            MpSUB(a, 0, x, 0, n, s, isign)
            MpMUL(s, 0, n, s, 0, n, s)
            MpMUL(s, 1, n, p, rpp, n, s)
            MpSUB(t, 0, s, n, n, t, isign)

            'a = x
            'p = 2p
            Array.Copy(x, 0, a, 0, n)
            MpSMU(p, rpp, n, 2, p)
            rpp = 1

            'Convergence Test
            Dim i As Integer
            For i = 0 To n - 2
                If a(i) <> b(i) Then Exit For
            Next

            Console.Write("Converging to about ")
            Console.Write(CInt(i * 2.405))
            Console.WriteLine(" digits")

            If i = n - 1 Then Exit Do
        Loop

        MpADD(a, 0, b, 0, n, x)
        MpMUL(x, 1, n, x, 1, n, s)
        MpSDV(s, 1, n, 4, s, ir)
        MpINV(t, 1, n, t)
        MpMUL(s, 0, n, t, 1, n, s)

        ReDim pi(np - 1)
        Array.Copy(s, 1, pi, 0, np)
    End Sub
End Module
